clear;
clc;
clearglobal;

D=0.0018;
J=0.00045;
k=0.015;
R=1.0;
L=0.003;

//r1 und r2 so whlen, das eine doppelte reelle Polstelle bei -10 entsteht:
doppelpolstelle = -10
r2 = (2*(-doppelpolstelle)-(D/J))*L-R
r1 = J*L*(1/k)*(-(D/J)*(R+r2)/L + 0.25*((R+r2)/L+D/J)^2)-k

//Stationre Werte fr i und omega bestimmen fr u=5Volt:
u = 5;
A = [-D/J,k/J;-k/L,-R/L];
b = [0;u/L]
y_stat = inv(A)*(-b);
w_stat = y_stat(1,1)
i_stat = y_stat(2,1)


//berprfen der Eigenwerte im *-System:

Astern = [-D/J,k/J;-(k+r1)/L,-(R+r2)/L];
spec(Astern)

//Rckfhrung auf tatschliche Systemmatrix und "Rest" und
//Simulation mit und ohne Regler:

//ungeregelt:
function f = rechteSeite(t,y)
    uu=5;
    AA = [-D/J,k/J;-k/L,-R/L];
    BB=[0;1/L]
    f=AA*y+BB*uu;
endfunction

//mit Zustandsregler:
function f = rechteSeite2(t,y)
    u=-r1*(y(1,1)-w_stat)-r2*(y(2,1)-i_stat)+k*w_stat+R*i_stat;
    B=[0;1/L]
    f=A*y+B*u;
endfunction
//oder alternativ:
function f = rechteSeite3(t,y)
    RR=[r1,r2];
    BB=[0;1/L];
    CC=[0;1];
    pp=(((k+r1)*w_stat+(R+r2)*i_stat)/L);
    f=(A-BB*RR)*y + CC*pp;
endfunction

t = 0:0.01:1;
y0 = [0,0]';
t0 = 0;
y  = ode(y0,t0,t,rechteSeite);
y2  = ode(y0,t0,t,rechteSeite3);

plot(t,y(1,:)','blu',t,y2(1,:)','gre');
a = gca();
a.x_label.text = 't/s';
a.y_label.text = 'y';
a.title.text = 'Vergleich Sprungantwort (u=5Volt) mit Zustandsregler';

a.legend_location="middle";

hl=legend(['Sprungantwort';'Zustandsregler'],a=1);



 


